/// <reference types="q" />
import * as plugins from "./smartnginx.plugins";
import { NginxHost } from "./smartnginx.classes.nginxhost";
import { NginxProcess } from "./smartnginx.classes.nginxprocess";
/**
 * main class that manages a NginxInstance
 */
export declare class NginxConfig {
    hosts: NginxHost[];
    cert: plugins.cert.Cert;
    nginxProcess: NginxProcess;
    isDeployed: boolean;
    constructor(optionsArg: plugins.cert.ICertConstructorOptions);
    addHost(nginxHostArg: NginxHost): void;
    listHosts(): NginxHost[];
    removeHost(nginxHostArg: NginxHost): void;
    clean(): void;
    deploy(): plugins.q.Promise<{}>;
}
